/// <reference types="node" />
import { PassThrough } from 'stream';
import { ZipsonWriter } from 'zipson';
/**
 * Write each part of the stringified data to a stream
 * Buffered by provided buffer size
 */
export declare class ZipsonStreamWriter extends ZipsonWriter {
    private bufferThreshold;
    private _stream;
    private _buffer;
    constructor(bufferThreshold?: number);
    write(data: string): void;
    end(): void;
    readonly stream: PassThrough;
}
