var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "stream", "zipson"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var stream_1 = require("stream");
    var zipson_1 = require("zipson");
    /**
     * Write each part of the stringified data to a stream
     * Buffered by provided buffer size
     */
    var ZipsonStreamWriter = /** @class */ (function (_super) {
        __extends(ZipsonStreamWriter, _super);
        function ZipsonStreamWriter(bufferThreshold) {
            if (bufferThreshold === void 0) { bufferThreshold = 250; }
            var _this = _super.call(this) || this;
            _this.bufferThreshold = bufferThreshold;
            _this._stream = new stream_1.PassThrough();
            _this._buffer = '';
            return _this;
        }
        ZipsonStreamWriter.prototype.write = function (data) {
            this._buffer += data;
            if (this._buffer.length > this.bufferThreshold) {
                this._stream.push(this._buffer);
                this._buffer = '';
            }
        };
        ZipsonStreamWriter.prototype.end = function () {
            if (this._buffer.length > 0) {
                this._stream.push(this._buffer);
                this._buffer = '';
            }
            this._stream.push(null);
        };
        Object.defineProperty(ZipsonStreamWriter.prototype, "stream", {
            get: function () {
                return this._stream;
            },
            enumerable: true,
            configurable: true
        });
        return ZipsonStreamWriter;
    }(zipson_1.ZipsonWriter));
    exports.ZipsonStreamWriter = ZipsonStreamWriter;
});
//# sourceMappingURL=ZipsonStreamWriter.js.map