(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "zipson", "./ZipsonStreamWriter"], factory);
    }
})(function (require, exports) {
    "use strict";
    function __export(m) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }
    Object.defineProperty(exports, "__esModule", { value: true });
    var zipson_1 = require("zipson");
    __export(require("./ZipsonStreamWriter"));
    /**
     * Parse a stream of zipson data
     * Returns a promise that resolves with the parsed result
     */
    function parseStream(stream) {
        return new Promise(function (resolve, reject) {
            var increment = zipson_1.parseIncremental();
            stream.on('error', reject);
            stream.on('end', function () {
                try {
                    resolve(increment(null));
                }
                catch (e) {
                    reject(e);
                }
            });
            stream.on('data', function (d) {
                try {
                    increment(d.toString());
                }
                catch (e) {
                    reject(e);
                }
            });
        });
    }
    exports.parseStream = parseStream;
});
//# sourceMappingURL=index.js.map